﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;

using System.Linq;

using Vintagestory.API.Common.Entities;
using Vintagestory.API.MathTools;

namespace Automap
{
	/// <summary>
	/// Actual Physical Point in space - that is interesting.
	/// </summary>
	public struct EntityOfInterest
	{
		public string Notes;
		public BlockPos Location;
		public DateTimeOffset Timestamp;
		public long EntityId;
	}

	/// <summary>
	/// Entities of interest.
	/// </summary>
	/// <remarks>Tracked by ID - these never leave.</remarks>
	public class EntitiesOfInterest : KeyedCollection<long, EntityOfInterest>
	{

		internal void AddReplace(EntityOfInterest entity)
		{
			if (Contains(entity.EntityId))
				Remove(entity.EntityId);

			Add(entity);
		}

		protected override long GetKeyForItem(EntityOfInterest item)
			=> item.EntityId;
	}
}

